diff -ruNp ejudge-2.3.18/misctext.c ejudge/misctext.c
--- ejudge-2.3.18/misctext.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/misctext.c	2011-07-11 09:02:04.552273234 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: misctext.c 6237 2011-04-08 18:47:35Z cher $ */
+/* $Id: misctext.c 6347 2011-05-23 19:06:12Z cher $ */
 
 /* Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -27,6 +27,7 @@
 #include <stdlib.h>
 #include <time.h>
 #include <ctype.h>
+#include <errno.h>
 
 #include "win32_compat.h"
 
@@ -1351,6 +1352,7 @@ is_empty_string(const unsigned char *s)
   return !*s;
 }
 
+#define SIZE_T (1024L * 1024L * 1024L * 1024L)
 #define SIZE_G (1024 * 1024 * 1024)
 #define SIZE_M (1024 * 1024)
 #define SIZE_K (1024)
@@ -1383,6 +1385,120 @@ size_t_to_size_str(
   return buf;
 }
 
+/*
+  parse an integral value in range -2147483648...2147483647 checking for overflow
+ */
+int
+size_str_to_num(const unsigned char *str, int *p_num)
+{
+  const unsigned char *s;
+  long value;
+  char *eptr = 0;
+  int suffix = 0;
+
+  if (!str) return -1;
+  s = str;
+  while (*s && isspace(*s)) ++s;
+  if (!*s) return -1;
+
+  errno = 0;
+  value = strtol(str, &eptr, 10);
+  if (errno) return -1;
+#if LONG_MAX != INT_MAX
+  if (value < INT_MIN || value > INT_MAX) return -1;
+#endif
+  s = (const unsigned char *) eptr;
+  if (*s && !isspace(*s)) {
+    suffix = toupper(*s);
+    if (suffix != 'K' && suffix != 'M' && suffix != 'G' && suffix != 'T')
+      return -1;
+    ++s; 
+  }
+  while (*s && isspace(*s)) ++s;
+  if (*s) return -1;
+  if (suffix == 'T') {
+    return -1;
+  } else if (suffix == 'G') {
+    if (value < -2 || value > 1) return -1;
+    value *= SIZE_G;
+  } else if (suffix == 'M') {
+    if (value < -2048 || value > 2047) return -1;
+    value *= SIZE_M;
+  } else if (suffix == 'K') {
+    if (value < -2097152 || value > 2097151) return -1;
+    value *= SIZE_K;
+  }
+
+  if (p_num) *p_num = (int) value;
+
+  return 0;
+}
+
+/*
+  parse an integral value in range LONG_MIN ... LONG_MAX checking for overflow 
+ */
+int
+size_str_to_size_t(const unsigned char *str, size_t *p_size)
+{
+  const unsigned char *s;
+  long value;
+  char *eptr = 0;
+  int suffix = 0;
+
+  if (!str) return -1;
+  s = str;
+  while (*s && isspace(*s)) ++s;
+  if (!*s) return -1;
+
+  errno = 0;
+  value = strtol(str, &eptr, 10);
+  if (errno) return -1;
+  s = (const unsigned char *) eptr;
+  if (*s && !isspace(*s)) {
+    suffix = toupper(*s);
+    if (suffix != 'K' && suffix != 'M' && suffix != 'G' && suffix != 'T')
+      return -1;
+    ++s; 
+  }
+  while (*s && isspace(*s)) ++s;
+  if (*s) return -1;
+
+#if INT_MAX == LONG_MAX
+  // 32-bit architecture
+  if (suffix == 'T') {
+    return -1;
+  } else if (suffix == 'G') {
+    if (value < -2 || value > 1) return -1;
+    value *= SIZE_G;
+  } else if (suffix == 'M') {
+    if (value < -2048 || value > 2047) return -1;
+    value *= SIZE_M;
+  } else if (suffix == 'K') {
+    if (value < -2097152 || value > 2097151) return -1;
+    value *= SIZE_K;
+  }
+#else
+  // 64-bit architecture. Note, this will not work for MSVC...
+  if (suffix == 'T') {
+    if (value < -8388608L || value > 8388607L) return -1;
+    value *= SIZE_T;
+  } else if (suffix == 'G') {
+    if (value < -8589934592L || value > 8589934591L) return -1;
+    value *= SIZE_G;
+  } else if (suffix == 'M') {
+    if (value < -8796093022208L || value > 8796093022207L) return -1;
+    value *= SIZE_M;
+  } else if (suffix == 'K') {
+    if (value < -9007199254740992L || value > 9007199254740991L) return -1;
+    value *= SIZE_K;
+  }
+#endif
+
+  if (p_size) *p_size = (size_t) value;
+
+  return 0;
+}
+
 int
 has_control_characters(const unsigned char *str)
 {
@@ -1930,6 +2046,47 @@ ucs2_to_utf8(
 }
 
 /*
+  returns: 0 - address invalid, 1 - valid
+ */
+int
+is_valid_email_address(const unsigned char *email_address)
+{
+  if (!email_address || !*email_address) return 0;
+  const unsigned char *p;
+  const unsigned char *at_ptr = 0;
+  for (p = email_address; *p; ++p) {
+    if (*p <= ' ' || *p >= 127 || *p == '\\' || *p == '\'' || *p == '\"')
+      return 0;
+    if (*p == '@') {
+      if (at_ptr) return 0;
+      at_ptr = p;
+    }
+  }
+  if (!at_ptr) return 0;
+  if (at_ptr == email_address || !at_ptr[1]) return 0;
+  // check domain part
+  for (p = at_ptr + 1; *p; ++p) {
+    if (!isalnum(*p) && *p != '-' && *p != '_' && *p != '.')
+      return 0;
+    if (*p == '.' && (p[-1] == '@' || !p[1] || p[1] == '.')) return 0;
+  }
+  // check local part
+  for (p = email_address; p < at_ptr; ++p) {
+    if (*p == '.') {
+      if (p == email_address || p[1] == '@' || p[1] == '.') return 0;
+    } else if (isalnum(*p)) {
+      // do nothing
+    } else if (*p == '!' || *p == '#' || *p == '+' || *p == '-' || *p == '/' || *p == '=' || *p == '?'
+               || *p == '^' || *p == '_' || *p == '~') {
+      // All valid chars: ! # $ % & * + - / = ? ^ _ ` { | } ~
+    } else {
+      return 0;
+    }
+  }
+  return 1;
+}
+
+/*
  * Local variables:
  *  compile-command: "make"
  *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
diff -ruNp ejudge-2.3.18/misctext.h ejudge/misctext.h
--- ejudge-2.3.18/misctext.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/misctext.h	2011-07-11 09:02:04.569272921 +0400
@@ -1,9 +1,9 @@
 /* -*- c -*- */
-/* $Id: misctext.h 6042 2010-11-18 08:48:22Z cher $ */
+/* $Id: misctext.h 6347 2011-05-23 19:06:12Z cher $ */
 #ifndef __MISCTEXT_H__
 #define __MISCTEXT_H__
 
-/* Copyright (C) 2000-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2000-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -251,4 +251,12 @@ html_print_by_line(
         unsigned char const *s,
         size_t size);
 
+int
+size_str_to_num(const unsigned char *str, int *p_num);
+int
+size_str_to_size_t(const unsigned char *str, size_t *p_size);
+
+int
+is_valid_email_address(const unsigned char *email_address);
+
 #endif /* __MISCTEXT_H__ */
diff -ruNp ejudge-2.3.18/new-server.c ejudge/new-server.c
--- ejudge-2.3.18/new-server.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new-server.c	2011-07-11 09:02:04.706270403 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: new-server.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: new-server.c 6323 2011-05-08 20:39:15Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -57,7 +57,7 @@ static struct server_framework_params pa
   .force_socket_flag = 0,
   .program_name = 0,
   .socket_path = "/tmp/new-server-socket",
-  .log_path = "/tmp/new-server.log",
+  .log_path = "/tmp/ej-contests.log",
   .select_timeout = 1,
   .user_data = 0,
   .startup_error = startup_error,
@@ -612,7 +612,7 @@ setup_log_file(void)
       && os_IsAbsolutePath(ejudge_config->new_server_log))
     return;
   if (ejudge_config->var_dir && os_IsAbsolutePath(ejudge_config->var_dir)) {
-    if (!(s1 = ejudge_config->new_server_log)) s1 = "new-server.log";
+    if (!(s1 = ejudge_config->new_server_log)) s1 = "ej-contests.log";
     snprintf(buf, sizeof(buf), "%s/%s", ejudge_config->var_dir, s1);
     xfree(ejudge_config->new_server_log);
     ejudge_config->new_server_log = xstrdup(buf);
@@ -620,7 +620,7 @@ setup_log_file(void)
   }
   if (ejudge_config->contests_home_dir
       && os_IsAbsolutePath(ejudge_config->contests_home_dir)){
-    if (!(s1 = ejudge_config->new_server_log)) s1 = "new-server.log";
+    if (!(s1 = ejudge_config->new_server_log)) s1 = "ej-contests.log";
     if (!(s2 = ejudge_config->var_dir)) s2 = "var";
     snprintf(buf, sizeof(buf), "%s/%s/%s", ejudge_config->contests_home_dir,
              s2, s1);
@@ -628,7 +628,7 @@ setup_log_file(void)
     ejudge_config->new_server_log = xstrdup(buf);
     return;
   }
-  ejudge_config->new_server_log = xstrdup("/tmp/new-server.log");
+  ejudge_config->new_server_log = xstrdup("/tmp/ej-contests.log");
 }
 
 int
diff -ruNp ejudge-2.3.18/new-server-cmd.c ejudge/new-server-cmd.c
--- ejudge-2.3.18/new-server-cmd.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new-server-cmd.c	2011-07-11 09:02:04.672271028 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: new-server-cmd.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: new-server-cmd.c 6381 2011-06-25 18:52:12Z cher $ */
 
 /* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
@@ -740,6 +740,7 @@ static const struct command_handler hand
   { "export-xml-runs", prepare_simple, 0, 0, NEW_SRV_ACTION_EXPORT_XML_RUNS},
   { "dump-all-runs", prepare_simple, 0, 0, NEW_SRV_ACTION_VIEW_RUNS_DUMP },
   { "dump-problems", prepare_simple, 0, 0, NEW_SRV_ACTION_DUMP_PROBLEMS },
+  { "dump-languages", prepare_simple, 0, 0, NEW_SRV_ACTION_DUMP_LANGUAGES },
   { "soft-update-stand", prepare_simple, 0, 0, NEW_SRV_ACTION_SOFT_UPDATE_STANDINGS },
   { "suspend-testing", prepare_simple, 0, 0, NEW_SRV_ACTION_TEST_SUSPEND },
   { "resume-testing", prepare_simple, 0, 0, NEW_SRV_ACTION_TEST_RESUME },
@@ -753,6 +754,10 @@ static const struct command_handler hand
   { "team-dump-clar", prepare_clar_id, 0, 0, NEW_SRV_ACTION_DUMP_CLAR },
   { "get-contest-name", prepare_simple, 0, 0, NEW_SRV_ACTION_GET_CONTEST_NAME },
   { "get-contest-type", prepare_simple, 0, 0, NEW_SRV_ACTION_GET_CONTEST_TYPE },
+  { "get-contest-status", prepare_simple, 0, 0, NEW_SRV_ACTION_GET_CONTEST_STATUS },
+  { "get-contest-sched", prepare_simple, 0, 0, NEW_SRV_ACTION_GET_CONTEST_SCHED },
+  { "get-contest-duration", prepare_simple, 0, 0, NEW_SRV_ACTION_GET_CONTEST_DURATION },
+  { "get-contest-description", prepare_simple, 0, 0, NEW_SRV_ACTION_GET_CONTEST_DESCRIPTION },
   { "submit-run", prepare_submit_run, 0, 0, 0 },
   { "team-submit-run", prepare_submit_run, 0, 0, 0 },
   { "import-xml-runs", prepare_import_xml, 0, 0, NEW_SRV_ACTION_UPLOAD_RUNLOG_XML_2 },
diff -ruNp ejudge-2.3.18/new-server.h ejudge/new-server.h
--- ejudge-2.3.18/new-server.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new-server.h	2011-07-11 09:02:04.710270329 +0400
@@ -1,5 +1,5 @@
 /* -*- c -*- */
-/* $Id: new-server.h 6116 2011-03-17 07:41:59Z cher $ */
+/* $Id: new-server.h 6381 2011-06-25 18:52:12Z cher $ */
 
 #ifndef __NEW_SERVER_H__
 #define __NEW_SERVER_H__
@@ -289,6 +289,7 @@ enum
   NEW_SRV_ACTION_UPLOAD_RUNLOG_XML_2,
   NEW_SRV_ACTION_LOGIN,         /* for new-server-cmd */
   NEW_SRV_ACTION_DUMP_PROBLEMS,
+  NEW_SRV_ACTION_DUMP_LANGUAGES,
   NEW_SRV_ACTION_SOFT_UPDATE_STANDINGS,
   NEW_SRV_ACTION_HAS_TRANSIENT_RUNS,
   NEW_SRV_ACTION_DUMP_RUN_STATUS,
@@ -296,6 +297,10 @@ enum
   NEW_SRV_ACTION_DUMP_CLAR,
   NEW_SRV_ACTION_GET_CONTEST_NAME,
   NEW_SRV_ACTION_GET_CONTEST_TYPE,
+  NEW_SRV_ACTION_GET_CONTEST_STATUS,
+  NEW_SRV_ACTION_GET_CONTEST_SCHED,
+  NEW_SRV_ACTION_GET_CONTEST_DURATION,
+  NEW_SRV_ACTION_GET_CONTEST_DESCRIPTION,
   NEW_SRV_ACTION_DUMP_MASTER_RUNS,
   NEW_SRV_ACTION_DUMP_REPORT,
   NEW_SRV_ACTION_FULL_UPLOAD_RUNLOG_XML,
@@ -609,16 +614,29 @@ ns_write_priv_clar(const serve_state_t c
                    struct contest_extra *extra,
                    int clar_id);
 
-void ns_header(FILE *out, unsigned char const *template,
-               unsigned char const *content_type,
-               unsigned char const *charset,
-               const unsigned char *script_part,
-               const unsigned char *body_attr,
-               int locale_id,
-               char const *format, ...)
-  __attribute__((format(printf, 8, 9)));
-void ns_footer(FILE *out, unsigned char const *templ,
-               const unsigned char *copyright, int locale_id);
+void
+ns_header(
+        FILE *out,
+        unsigned char const *template,
+        unsigned char const *content_type,
+        unsigned char const *charset,
+        const unsigned char *script_part,
+        const unsigned char *body_attr,
+        int locale_id,
+        const struct contest_desc *cnts,
+        char const *format,
+        ...)
+  __attribute__((format(printf, 9, 10)));
+void
+ns_separator(
+        FILE *out,
+        unsigned char const *templ,
+        const struct contest_desc *cnts);
+void ns_footer(
+        FILE *out,
+        unsigned char const *templ,
+        const unsigned char *copyright,
+        int locale_id);
 
 const unsigned char *ns_unparse_role(int role);
 
diff -ruNp ejudge-2.3.18/new_server_html_2.c ejudge/new_server_html_2.c
--- ejudge-2.3.18/new_server_html_2.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new_server_html_2.c	2011-07-11 09:02:04.765269318 +0400
@@ -1,5 +1,5 @@
 /* -*- mode: c -*- */
-/* $Id: new_server_html_2.c 6162 2011-03-27 07:07:27Z cher $ */
+/* $Id: new_server_html_2.c 6393 2011-07-04 20:54:33Z cher $ */
 
 /* Copyright (C) 2006-2010 Alexander Chernov <cher@ejudge.ru> */
 
@@ -1089,7 +1089,7 @@ ns_write_priv_source(const serve_state_t
   if (info.lang_id > 0 && info.lang_id <= state->max_lang)
     lang = state->langs[info.lang_id];
 
-  ns_header(f, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(f, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %s]: %s %d", ns_unparse_role(phr->role),
             phr->name_arm, extra->contest_arm,
             _("Viewing run"), run_id);
@@ -1643,17 +1643,6 @@ ns_write_priv_source(const serve_state_t
                      "run_id=%d&no_disp=1", run_id));
     } else {
       fprintf(f, "<p>The submission is binary and thus is not shown.</p>\n");
-      /* try to load text description of the archive */
-      txt_flags = archive_make_read_path(state, txt_path, sizeof(txt_path),
-                                         global->report_archive_dir,
-                                         run_id, 0, 0);
-      if (txt_flags >= 0) {
-        if (generic_read_file(&txt_text, 0, &txt_size, txt_flags, 0,
-                              txt_path, 0) >= 0) {
-          fprintf(f, "<pre>%s</pre>\n", ARMOR(txt_text));
-          xfree(txt_text); txt_text = 0; txt_size = 0;
-        }
-      }
     }
   } else if (lang && lang->binary) {
     fprintf(f, "<p>The submission is binary and thus is not shown.</p>\n");
@@ -1696,6 +1685,18 @@ ns_write_priv_source(const serve_state_t
     */
   }
 
+    /* try to load text description of the archive */
+  txt_flags = archive_make_read_path(state, txt_path, sizeof(txt_path),
+                                     global->report_archive_dir,
+                                     run_id, 0, 0);
+  if (txt_flags >= 0) {
+    if (generic_read_file(&txt_text, 0, &txt_size, txt_flags, 0,
+                          txt_path, 0) >= 0) {
+      fprintf(f, "<h2>%s</h2>\n<pre>%s</pre>\n", "Style checker output", ARMOR(txt_text));
+      xfree(txt_text); txt_text = 0; txt_size = 0;
+    }
+  }
+
   fprintf(f, "<h2>%s</h2>\n", _("Send a message about this run"));
   html_start_form_id(f, 1, phr->self_url, "run_comment", phr->hidden_vars);
   html_hidden(f, "run_id", "%d", run_id);
@@ -1815,7 +1816,7 @@ ns_write_priv_report(const serve_state_t
     content_type = get_content_type(rep_text, &start_ptr);
   }
 
-  ns_header(f, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(f, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %s]: %s %d", ns_unparse_role(phr->role),
             phr->name_arm, extra->contest_arm,
             team_report_flag?_("Viewing user report"):_("Viewing report"),
@@ -1852,7 +1853,8 @@ ns_write_priv_report(const serve_state_t
       }
     } else {
       if (team_report_flag) {
-        write_xml_team_testing_report(cs, prob, f, 0, re.is_marked, start_ptr, "b1");
+        write_xml_team_testing_report(cs, prob, f, 0, re.is_marked, start_ptr, "b1", phr->session_id, phr->self_url, "",
+                                      new_actions_vector);
       } else {
         write_xml_testing_report(f, 0, start_ptr, phr->session_id,phr->self_url,
                                  "", new_actions_vector, "b1", 0);
@@ -1917,7 +1919,7 @@ ns_write_audit_log(const serve_state_t c
   }
   audit_html = html_armor_string_dup(audit_text);
 
-  ns_header(f, extra->header_txt, 0, 0, 0, 0, phr->locale_id,
+  ns_header(f, extra->header_txt, 0, 0, 0, 0, phr->locale_id, cnts,
             "%s [%s, %s]: %s %d", ns_unparse_role(phr->role),
             phr->name_arm, extra->contest_arm,
             _("Viewing audit log for"), run_id);
@@ -3461,7 +3463,7 @@ ns_write_priv_standings(
 
   if (state->global->score_system == SCORE_KIROV
       || state->global->score_system == SCORE_OLYMPIAD)
-    do_write_kirov_standings(state, cnts, f, 0, 1, 0, 0, 0, 0, 0 /*accepting_mode*/, 1, 0, 0, u, 0 /* user_mode */);
+    do_write_kirov_standings(state, cnts, f, 0, 1, 0, 0, 0, 0, 0, 0 /*accepting_mode*/, 1, 0, 0, u, 0 /* user_mode */);
   else if (state->global->score_system == SCORE_MOSCOW)
     do_write_moscow_standings(state, cnts, f, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0,
                               u);
diff -ruNp ejudge-2.3.18/new_server_html_3.c ejudge/new_server_html_3.c
--- ejudge-2.3.18/new_server_html_3.c	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/new_server_html_3.c	2011-07-11 09:02:04.047282518 +0400
@@ -1,7 +1,7 @@
 /* -*- mode: c -*- */
-/* $Id: new_server_html_3.c 5675 2010-01-19 09:52:11Z cher $ */
+/* $Id: new_server_html_3.c 6353 2011-05-28 07:35:10Z cher $ */
 
-/* Copyright (C) 2006-2009 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2006-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -73,7 +73,7 @@ const unsigned char ns_fancy_header[] =
 "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n"
 "<html><head>\n<meta http-equiv=\"Content-type\" content=\"text/html; charset=%C\"/>\n"
 "%S"
-"<link rel=\"stylesheet\" href=\"" CONF_STYLE_PREFIX "unpriv.css\" type=\"text/css\"/>\n"
+"<link rel=\"stylesheet\" href=\"%Y\" type=\"text/css\"/>\n"
   //"<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"/favicon.ico\"/>\n"
 "<title>%H</title></head>\n"
   //"<body onload=\"startClock()\">"
@@ -89,7 +89,7 @@ const unsigned char ns_fancy_empty_statu
 "<td class=\"menu\"><div class=\"contest_actions_item\">&nbsp;</div></td></tr></table></div>\n";
 const unsigned char ns_fancy_separator[] =
 "</div>\n"
-"<div id=\"l11\"><img src=\"" CONF_STYLE_PREFIX "logo.gif\" alt=\"ejudge logo\"/></div>\n"
+"<div id=\"l11\"><img src=\"%O\" alt=\"logo\"/></div>\n"
 "<div id=\"l13\">\n";
 const unsigned char ns_fancy_footer[] =
 "<div id=\"footer\">%R</div>\n"
@@ -118,15 +118,18 @@ const unsigned char * const ns_ssl_flag_
 };
 
 static void
-process_template(FILE *out,
-                 unsigned char const *templ,
-                 unsigned char const *content_type,
-                 unsigned char const *charset,
-                 unsigned char const *title,
-                 unsigned char const *copyright,
-                 const unsigned char *script_part,
-                 const unsigned char *body_attr,
-                 int locale_id)
+process_template(
+        FILE *out,
+        unsigned char const *templ,
+        unsigned char const *content_type,
+        unsigned char const *charset,
+        unsigned char const *title,
+        unsigned char const *copyright,
+        const unsigned char *script_part,
+        const unsigned char *body_attr,
+        int locale_id,
+        const unsigned char *logo_url,
+        const unsigned char *css_url)
 {
   unsigned char const *s = templ;
 
@@ -157,6 +160,12 @@ process_template(FILE *out,
     case 'B':
       fputs(body_attr, out);
       break;
+    case 'O':
+      fputs(logo_url, out);
+      break;
+    case 'Y':
+      fputs(css_url, out);
+      break;
     default:
       putc('%', out);
       continue;
@@ -166,16 +175,22 @@ process_template(FILE *out,
 }
 
 void
-ns_header(FILE *out, unsigned char const *templ,
-          unsigned char const *content_type,
-          unsigned char const *charset,
-          const unsigned char *script_part,
-          const unsigned char *body_attr,
-          int locale_id,
-          char const *format, ...)
+ns_header(
+        FILE *out,
+        unsigned char const *templ,
+        unsigned char const *content_type,
+        unsigned char const *charset,
+        const unsigned char *script_part,
+        const unsigned char *body_attr,
+        int locale_id,
+        const struct contest_desc *cnts,
+        char const *format,
+        ...)
 {
   va_list args;
   unsigned char title[1024];
+  const unsigned char *logo_url = 0;
+  const unsigned char *css_url = 0;
 
   title[0] = 0;
   if (format) {
@@ -190,21 +205,63 @@ ns_header(FILE *out, unsigned char const
   if (!script_part) script_part = "";
   if (!body_attr) body_attr = "";
 
+  if (cnts) {
+    logo_url = cnts->logo_url;
+    css_url = cnts->css_url;
+  }
+  if (!logo_url) {
+#if defined CONF_STYLE_PREFIX
+    logo_url = CONF_STYLE_PREFIX "logo.gif";
+#else
+    logo_url = "logo.gif";
+#endif
+  }
+  if (!css_url) {
+#if defined CONF_STYLE_PREFIX
+    css_url = CONF_STYLE_PREFIX "unpriv.css";
+#else
+    css_url = "unpriv.css";
+#endif
+  }
+
   fprintf(out, "Content-Type: %s; charset=%s\n"
           "Cache-Control: no-cache\n"
           "Pragma: no-cache\n\n", content_type, charset);
 
   process_template(out, templ, content_type, charset, title, 0,
-                   script_part, body_attr, locale_id);
+                   script_part, body_attr, locale_id, logo_url, css_url);
+}
+
+void
+ns_separator(
+        FILE *out,
+        unsigned char const *templ,
+        const struct contest_desc *cnts)
+{
+  const unsigned char *logo_url = 0;
+
+  if (cnts) logo_url = cnts->logo_url;
+  if (!logo_url) {
+#if defined CONF_STYLE_PREFIX
+    logo_url = CONF_STYLE_PREFIX "logo.gif";
+#else
+    logo_url = "logo.gif";
+#endif
+  }
+
+  process_template(out, templ, NULL, NULL, NULL, NULL, NULL, NULL, 0, logo_url, NULL);
 }
 
 void
-ns_footer(FILE *out, unsigned char const *templ,
-          const unsigned char *copyright, int locale_id)
+ns_footer(
+        FILE *out,
+        unsigned char const *templ,
+        const unsigned char *copyright,
+        int locale_id)
 {
   if (!copyright) copyright = get_copyright(locale_id);
   if (!templ) templ = ns_default_footer;
-  process_template(out, templ, 0, 0, 0, copyright, 0, 0, 0);
+  process_template(out, templ, 0, 0, 0, copyright, 0, 0, 0, NULL, NULL);
 }
 
 void
@@ -259,10 +316,10 @@ ns_html_err_no_perm(FILE *fout,
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Permission denied"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Permission denied"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("Permission denied. The possible reasons are as follows."));
@@ -354,10 +411,10 @@ ns_html_err_simple_registered(
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Cannot participate"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Cannot participate"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("You cannot participate in this contest. Your account was created using the simple registration procedure, i.e. your e-mail address was not verified. This contest requires e-mail verification, so your account cannot be accepted."));
@@ -441,10 +498,10 @@ ns_html_err_inv_param(FILE *fout,
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Invalid parameter"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Invalid parameter"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("A request parameter is invalid. Please, contact the site administrator."));
@@ -502,10 +559,10 @@ ns_html_err_service_not_available(FILE *
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Service not available"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Service not available"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("Service that you requested is not available."));
@@ -563,10 +620,10 @@ ns_html_err_cnts_unavailable(FILE *fout,
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Contest not available"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Contest not available"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("The contest is temporarily not available. Please, retry the request a bit later."));
@@ -629,11 +686,11 @@ ns_html_err_ul_server_down(FILE *fout,
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id,
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts,
             _("User database server is down"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("The user database server is currently not available. Please, retry the request later."));
@@ -696,10 +753,10 @@ ns_html_err_internal_error(FILE *fout,
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Internal error"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Internal error"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("Your request has caused an internal server error. Please, report it as a bug."));
@@ -762,10 +819,10 @@ ns_html_err_inv_session(FILE *fout,
     }    
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Invalid session"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Invalid session"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("Invalid session identifier. The possible reasons are as follows."));
@@ -839,10 +896,10 @@ ns_html_err_registration_incomplete(
     else footer = ns_fancy_footer;
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("Registration incomplete"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("Registration incomplete"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
 
   if (cnts && cnts->allow_reg_data_edit
@@ -899,10 +956,10 @@ ns_html_err_disqualified(
     else footer = ns_fancy_footer;
   }
   l10n_setlocale(phr->locale_id);
-  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, _("You are disqualified"));
+  ns_header(fout, header, 0, 0, 0, 0, phr->locale_id, cnts, _("You are disqualified"));
   if (separator && *separator) {
     fprintf(fout, "%s", ns_fancy_empty_status);
-    fprintf(fout, "%s", separator);
+    ns_separator(fout, separator, cnts);
   }
   fprintf(fout, "<p>%s</p>\n",
           _("You are disqualified by the contest administration."));
